# duplicity

#### Table of Contents

1. [Description](#description)
1. [Setup - The basics of getting started with duplicity](#setup)
    * [What duplicity affects](#what-duplicity-affects)
    * [Setup requirements](#setup-requirements)
    * [Beginning with duplicity](#beginning-with-duplicity)
1. [Usage - Configuration options and additional functionality](#usage)

## Description

Install and configure *duplicity* on Ubuntu Linux.

Create scripts with backup jobs and add cron tasks.

## Setup

### What duplicity affects **OPTIONAL**

If it's obvious what your module touches, you can skip this section. For
example, folks can probably figure out that your mysql_instance module affects
their MySQL instances.

If there's more that they should know about, though, this is the place to mention:

* A list of files, packages, services, or operations that the module will alter,
  impact, or execute.
* Dependencies that your module automatically installs.
* Warnings or other important notices.

### Setup Requirements **OPTIONAL**

Before make backups you need to be sure you can connect to destination url.

### Beginning with duplicity

(https://forge.puppetlabs.com/opstudio/duplicity/readme)

Install module
```
puppet module install opstudio-duplicity
```
## Usage

Example configuration
```
include duplicity::install

$jira_home                = '/var/atlassian/application-data/jira'
$jira_install_dir         = '/opt/atlassian/jira'
$backup_server            = "192.168.0.251"
$backup_user              = "backup_user"
$backup_transfer_type     = "rsync"
$backup_base              = "/backup"
$backup_agent_node        = $::hostname
$full_backup_interval     = '2W'
$last_full_backup_to_keep = '24'
$last_increment_to_keep   = '110'
$backup_schedule_hours    = [3, 9, 15, 21]
$cleanup_schedule_hours   = [4]

$source_dirs = [$jira_home, $jira_install_dir]
$ignore_dirs = ["$jira_home/tmp/*", "$jira_home/caches/*", "$jira_install_dir/temp/*"]

duplicity::backup_job { "jira":
  backup_server            => $backup_server,
  backup_user              => $backup_user,
  backup_transfer_type     => $backup_transfer_type,
  backup_base              => $backup_base,
  source_dirs              => $source_dirs,
  ignore_dirs              => $ignore_dirs,
  full_backup_interval     => '2W',
  last_full_backup_to_keep => '24',
  last_increment_to_keep   => '110',
  backup_schedule_hours    => $backup_schedule_hours,
  cleanup_schedule_hours   => $cleanup_schedule_hours,
  force_create_dir_by_ssh  => true,
}

```
fancy stuff with your module here. It's especially helpful if you include usage
examples and code samples for doing things with your module.
