###############################################################################
# TODO: move encrytion to the separated template
###############################################################################

define duplicity::backup_job (
  $ensure                   = 'present',
  $backup_server            = "192.168.0.251",
  $backup_user              = "backup_user",
  $backup_transfer_type     = "rsync",
  $backup_base              = "/backup",
  $backup_agent_node        = $::hostname,
  $source_dirs              = [],
  $ignore_dirs              = [],
  # How often make full backup
  $full_backup_interval     = '2W',
  # Each month we will have 2 full backups; we need to keep 1 year so 24 backup totally
  $last_full_backup_to_keep = '24',
  # Since script will run every 12 hours we have 1 full + 27 incremets in two weeks; in two month it is
  $last_increment_to_keep   = '110',
  $force_create_dir_by_ssh  = false,
  $backup_schedule_hours    = [3, 9, 15, 21],
  $cleanup_schedule_hours   = [4],) {
  file { "backup_job_${name}":
    path    => "/usr/local/bin/backup_job.${name}",
    owner   => 'root',
    group   => 'root',
    mode    => '0755',
    content => template("duplicity/backup_job.sh.erb"),
    ensure  => $ensure,
    require => Class["duplicity::install"],
  } ->
  cron { "backup_job_${name}_backup":
    command => "/usr/local/bin/backup_job.${name} backup",
    user    => root,
    hour    => $backup_schedule_hours,
    minute  => fqdn_rand(59),
  } ->
  cron { "backup_job_${name}_cleanup":
    command => "/usr/local/bin/backup_job.${name} cleanup",
    user    => root,
    hour    => $cleanup_schedule_hours,
    minute  => fqdn_rand(59),
  }
}
